<?php
//--------------------------------------------------------------------
// *** PULLDOWN ***
// LAST UPDATE: 2009/06/16
// Version    : 1.45
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// viewer.php
//
//--------------------------------------------------------------------

// GET メソッド
if ($blogn_get_cl === "0" || $blogn_get_c === "0" || $blogn_get_ml === "0" || $blogn_get_m === "0") header("Location: index.php");

// POST メソッド
if ($blogn_get_mode == "pdm") {
	$blogn_mod_pulldown_mode = htmlspecialchars($_POST["pdmmode"]);
	$blogn_mod_pulldown_link = $_POST["pdmlink"];
	switch ($blogn_mod_pulldown_mode) {
		case "m":
		case "ml":
			if (!preg_match("/^\d{6}$/", $blogn_mod_pulldown_link)) $blogn_mod_pulldown_link = "";
			break;
		case "c":
		case "cl":
			if (!preg_match("/^\d+-\d*$/", $blogn_mod_pulldown_link)) $blogn_mod_pulldown_link = "";
			break;
		default:
			$blogn_mod_pulldown_link = "";
			break;
	}
	if (!$blogn_mod_pulldown_link) {
		header("Location: index.php");
	} else { 
		header("Location: index.php?$blogn_mod_pulldown_mode=$blogn_mod_pulldown_link");
	}
	exit;
}

if ($blogn_mod_alist_ini["cl_redirect"]) {
	$blogn_mod_pulldown_clist = array("link" => "cl", "id" => $blogn_get_cl);
} else {
	$blogn_mod_pulldown_clist = array("link" => "c", "id" => $blogn_get_c);
}
if ($blogn_mod_alist_ini["ml_redirect"]) {
	$blogn_mod_pulldown_mlist = array("link" => "ml", "id" => $blogn_get_ml);
} else {
	$blogn_mod_pulldown_mlist = array("link" => "m", "id" => $blogn_get_m);
}

$blogn_mod_pulldown_inifile = BLOGN_MODDIR."pulldown/config.cgi";
$blogn_mod_pulldown_inis = file($blogn_mod_pulldown_inifile);
list($blogn_mod_pulldown_ini["ar_switch"], $blogn_mod_pulldown_ini["ca_switch"], $blogn_mod_pulldown_ini["ar_count"], $blogn_mod_pulldown_ini["ar_title"], $blogn_mod_pulldown_ini["ca_title"], $blogn_mod_pulldown_ini["mb_count"], $blogn_mod_pulldown_ini["ns_button"]) = explode(",", $blogn_mod_pulldown_inis[0]);

$blogn_mod_pulldown_count = BLOGN_MOBILE_KEY ? $blogn_mod_pulldown_ini["mb_count"] : $blogn_mod_pulldown_ini["ar_count"];
	
if ($blogn_mod_pulldown_ini["ar_switch"]) $blogn_skin = blogn_mod_pulldown_archives_output($blogn_user, $blogn_skin, $blogn_mod_pulldown_mlist, $blogn_mod_pulldown_ini["ar_title"], $blogn_mod_pulldown_count, $blogn_mod_pulldown_ini["ns_button"]);
if ($blogn_mod_pulldown_ini["ca_switch"]) $blogn_skin = blogn_mode_pulldown_category_output($blogn_user, $blogn_skin, $blogn_mod_pulldown_clist, $blogn_mod_pulldown_ini["ca_title"], $blogn_mod_pulldown_ini["ns_button"]);

/* ----- 月別アーカイブプルダウンメニュー化 ----- */
function blogn_mod_pulldown_archives_output($user, $skin, $list, $title, $count, $button) {
	$mode = "";
	if (strpos($skin, "{PDM_AR}") && strpos($skin, "{/PDM_AR}")) {
		$mode = "js";
	} elseif (strpos($skin, "{PDM_ARNS}") && strpos($skin, "{/PDM_AR}")) {
		$mode = "ns";
	}
	if (!$mode) return $skin;
	
	$archivelist = blogn_mod_db_archive_count_load($user, $count);

	if (strpos($skin, "{PDM_ARLOOP}") && strpos($skin, "{/PDM_ARLOOP}")) {
		list($skin1,$buf,$skin2) = blogn_word_sepa("{PDM_ARLOOP}", "{/PDM_ARLOOP}", $skin);
	} elseif (strpos($skin, "{PDM_ARLOOPASC}") && strpos($skin, "{/PDM_ARLOOPASC}")) {
		list($skin1,$buf,$skin2) = blogn_word_sepa("{PDM_ARLOOPASC}", "{/PDM_ARLOOPASC}", $skin);
		ksort($archivelist[1]);
	}
	$skin3 = "";
	$selection = 0;		// option 要素の初期値フラグ
	if ($archivelist[0]) {
		foreach ($archivelist[1] as $key => $val) {
			$tmpbuf = $buf;
			if ($key != $list["id"]) {
				$PARlink["js"] = '<option value="index.php?'.$list["link"].'='.$key.'">';
				$PARlink["ns"] = '<option value="'.$key.'">';
				$selection = $selection + 0;
			} else {
				$PARlink["js"] = '<option value="index.php?'.$list["link"].'='.$key.'" selected="selected">';
				$PARlink["ns"] = '<option value="'.$key.'" selected="selected">';
				$selection = $selection + 1;
			}
			$PARlinke = '</option>';
			$PARcount = (int)$val;
			$tmpbuf = str_replace("{PDM_ARCOUNT}", $PARcount, $tmpbuf);
			if (strpos($tmpbuf, "{PDM_ARYM}") && strpos($tmpbuf, "{/PDM_ARYM}")) {
				list($dat1,$dd,$dat2) = blogn_word_sepa("{PDM_ARYM}", "{/PDM_ARYM}", $tmpbuf);
				$tmpbuf = $dat1.date($dd,mktime(0,0,0,substr($key,4,2), 1, substr($key,0,4))).$dat2;
			}
			$tmpbuf = str_replace("{PDM_ARLINK}", $PARlink[$mode], $tmpbuf);
			$tmpbuf = str_replace("{/PDM_ARLINK}", $PARlinke, $tmpbuf);
			$skin3 .= $tmpbuf;
		}
		$skin = $skin1.$skin3.$skin2;

		if (!$selection) $select = ' selected="selected"';
			
		$pre_form["js"] = '<form name="pdm_arform" id="pdm_arform">
<select name="pdm_arslct" id="pdm_arslct" onchange="location=this.value">
<option value=""'.$select.'>'.$title.'</option>';
		$pre_form["ns"] = '<form name="pdm_arform" id="pdm_arform" method="get" action="index.php">
<select name="'.$list["link"].'" id="pdm_arslct">
<option value="0"'.$select.'>'.$title.'</option>';
		$pre_form["ps"] = '<form name="pdm_arform" id="pdm_arform" method="post" action="index.php?mode=pdm">
<input type="hidden" name="pdmmode" value="'.$list["link"].'">
<select name="pdmlink" id="pdm_arslct">
<option value="index"'.$select.'>'.$title.'</option>';
		$post_form ="</select>\r\n";
		if ($mode == "ns") $post_form .= '<input type="submit" value="'.$button.'" id="pdm_arbutton">';
		$post_form .= "\r\n</form>";

		if ($mode == "js") {
			$skin = str_replace("{PDM_AR}", $pre_form["js"], $skin);
			$skin = str_replace("{/PDM_AR}", $post_form, $skin);
		} elseif (BLOGN_MOBILE_KEY) {
			$skin = str_replace("{PDM_ARNS}", $pre_form["ps"], $skin);
			$skin = str_replace("{/PDM_AR}", $post_form, $skin);
		} else {
			$skin = str_replace("{PDM_ARNS}", $pre_form["ns"], $skin);
			$skin = str_replace("{/PDM_AR}", $post_form, $skin);
		}
	} else {
		$skin = preg_replace("/\{PDM_AR(NS)*\}[\w\W]+?\{\/PDM_AR\}/", "", $skin);
	}
	return $skin;
}

/* ----- カテゴリー一覧プルダウンメニュー化 ----- */
function blogn_mode_pulldown_category_output($user, $skin, $list, $title, $button) {
	$mode = "";
	if (strpos($skin, "{PDM_CA}") && strpos($skin, "{/PDM_CA}")) {
		$mode = "js";
	} elseif (strpos($skin, "{PDM_CANS}") && strpos($skin, "{/PDM_CA}")) {
		$mode = "ns";
	} elseif (strpos($skin, "{PDM_CAH}") && strpos($skin, "{/PDM_CA}")) {
		$mode = "hs";
	} elseif (strpos($skin, "{PDM_CAHNS}") && strpos($skin, "{/PDM_CA}")) {
		$mode = "hn";
	}
	if (!$mode) return $skin;

	$category1 = blogn_mod_db_category1_load();
	$selection = 0;		// option 要素の初期値フラグ
	if ($category1[0]) {
		$category2 = blogn_mod_db_category2_load();

		list($skin1,$buf,$skin2) = blogn_word_sepa("{PDM_CALOOP1}", "{/PDM_CALOOP1}", $skin);
		list($buf1,$buf2,$buf3) = blogn_word_sepa("{PDM_CALOOP2}", "{/PDM_CALOOP2}", $buf);
		$skin3 = "";
		while (list($c1key, $c1val) = each($category1[1])) {
			$tmpbuf = $buf1;
			$c1id = $c1key."-";
			$count = blogn_mod_db_log_count_load($user, "category", $c1id);
			if ($count) {
				$CAtitle = get_magic_quotes_gpc() ? stripslashes($c1val["name"]) : $c1val["name"];	//￥を削除
				if ($c1id != $list["id"]) { 
					$CAlink["js"] = '<option value="index.php?'.$list["link"].'='.$c1id.'">';
					$CAlink["ns"] = '<option value="'.$c1id.'">';
					$CAlink["hs"] = '<a href="index.php?'.$list["link"].'='.$c1id.'">';
					$CAlink["hn"] = '<a href="index.php?'.$list["link"].'='.$c1id.'">';
					$selection = $selection + 0;
				} else {
					$CAlink["js"] = '<option value="index.php?'.$list["link"].'='.$c1id.'" selected="selected">';
					$CAlink["ns"] = '<option value="'.$c1id.'" selected="selected">';
					$CAlink["hs"] = '<a href="index.php?'.$list["link"].'='.$c1id.'">';
					$CAlink["hn"] = '<a href="index.php?'.$list["link"].'='.$c1id.'">';
					$selection = $selection + 1;
				}
				if ($mode == "hs" || $mode == "hn") {
					$CAlinke = "</a>";
				} else {
					$CAlinke = "</option>";
				}
				$tmpbuf = str_replace("{PDM_CATITLE1}", $CAtitle, $tmpbuf);
				$tmpbuf = str_replace("{PDM_CALINK1}", $CAlink[$mode], $tmpbuf);
				$tmpbuf = str_replace("{/PDM_CALINK1}", $CAlinke, $tmpbuf);
				$tmpbuf = str_replace("{PDM_CACOUNT1}", $count, $tmpbuf);
				$skin3 .= $tmpbuf;

				if ($category2[0]) {
					reset($category2[1]);
					while (list($c2key, $c2val) = each($category2[1])) {
						if ($c1key == $c2val["id"]) {
							$tmpbuf = $buf2;
							$c1c2id = $c1id.$c2key;
							$count = blogn_mod_db_log_count_load($user, "category", $c1c2id);
							if ($count) {
								$CAtitle = get_magic_quotes_gpc() ? stripslashes($c2val["name"]) : $c2val["name"];	//￥を削除
								if ($c1c2id != $list["id"]) {
									$CAlink["js"] = '<option value="index.php?'.$list["link"].'='.$c1c2id.'">';
									$CAlink["ns"] = '<option value="'.$c1c2id.'">';
									$CAlink["hs"] = '<option value="index.php?'.$list["link"].'='.$c1c2id.'">';
									$CAlink["hn"] = '<option value="'.$c1c2id.'">';
									$selection = $selection + 0;
								} else {
									$CAlink["js"] = '<option value="index.php?'.$list["link"].'='.$c1c2id.'" selected="selected">';
									$CAlink["ns"] = '<option value="'.$c1c2id.'" selected="selected">';
									$CAlink["hs"] = '<option value="index.php?'.$list["link"].'='.$c1c2id.'" selected="selected">';
									$CAlink["hn"] = '<option value="'.$c1c2id.'" selected="selected">';
									$selection = $selection + 1;
								}
								$CAcount = (int)$count;
								$tmpbuf = str_replace("{PDM_CATITLE2}", $CAtitle, $tmpbuf);
								$tmpbuf = str_replace("{PDM_CALINK2}", $CAlink[$mode], $tmpbuf);
								$tmpbuf = str_replace("{/PDM_CALINK2}", "</option>", $tmpbuf);
								$tmpbuf = str_replace("{PDM_CACOUNT2}", $count, $tmpbuf);
								$skin3 .= $tmpbuf;
							}
						}
					}
				}
				$skin3 .= $buf3;
			}
		}
		$skin = $skin1.$skin3.$skin2;
		
		if (!$selection) $select = ' selected="selected"';
			
		$pre_form["js"] = '<form name="pdm_caform" id="pdm_caform">
<select name="pdm_caslct" id="pdm_caslct" onchange="location=this.value">
<option value=""'.$select.'>'.$title.'</option>';
		$pre_form["ns"] = '<form name="pdm_caform" id="pdm_caform" method="get" action="index.php">
<select name="'.$list["link"].'" id="pdm_caslct">
<option value="0"'.$select.'>'.$title.'</option>';
		$pre_form["ps"] = '<form name="pdm_caform" id="pdm_caform" method="post" action="index.php?mode=pdm">
<input type="hidden" name="pdmmode" value="'.$list["link"].'">
<select name="pdmlink" id="pdm_caslct">
<option value="index"'.$select.'>'.$title.'</option>';
		$pre_form["hs"] = '<form name="pdm_caform" id="pdm_caform">
';

		$post_form = "</select>\r\n";
		if ($mode == "ns") $post_form .= '<input type="submit" value="'.$button.'" id="pdm_cabutton">';
		$post_form .= "\r\n</form>";
		
		if ($mode == "js") {
			$skin = str_replace("{PDM_CA}", $pre_form["js"], $skin);
			$skin = str_replace("{/PDM_CA}", $post_form, $skin);
		} elseif ($mode == "hs") {
			$skin = str_replace("{PDM_CAH}", $pre_form["hs"], $skin);
			$skin = str_replace("{/PDM_CA}", "</form>", $skin);
		} elseif ($mode == "hn") {
			$skin = str_replace("{PDM_CAHNS}", "", $skin);
			$skin = str_replace("{/PDM_CA}", "", $skin);
		} elseif (BLOGN_MOBILE_KEY) {
			$skin = str_replace("{PDM_CANS}", $pre_form["ps"], $skin);
			$skin = str_replace("{/PDM_CA}", $post_form, $skin);
		} else {
			$skin = str_replace("{PDM_CANS}", $pre_form["ns"], $skin);
			$skin = str_replace("{/PDM_CA}", $post_form, $skin);
		}			
	} else {
		$skin = preg_replace("/\{PDM_CA(NS)*\}[\w\W]+?\{\/PDM_CA\}/", "", $skin);
	}
	return $skin;
}

?>
