<?php
//--------------------------------------------------------------------
// *** PULLDOWN ***
// LAST UPDATE: 2009/06/16
// Version    : 1.45
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// control.php
//
//--------------------------------------------------------------------

$module_version = "1.45";

global $blogn_admin;
if (!$blogn_admin) exit;

$menu = array(1 => "設定", "独自タグ", "インストール", "モジュール情報");
$loadtabs = "1";

$inifile = BLOGN_MODDIR."pulldown/config.cgi";

$inis = file($inifile);
list($ar_swtch, $ca_swtch, $ar_count, $ar_title, $ca_title, $mb_count, $ns_button, ) = explode(",", $inis[0]);

switch($_POST["method"]) {
	case "edit":
		$ar_count 	= $_POST["ar_count"];
		$mb_count 	= $_POST["mb_count"];
		$ar_title 	= str_replace(",", "&#44;", trim(htmlspecialchars($_POST["ar_title"])));
		if (!$ar_title) $ar_title = "月別アーカイブ";
		$ca_title 	= str_replace(",", "&#44;", trim(htmlspecialchars($_POST["ca_title"])));
		if (!$ca_title) $ca_title = "カテゴリー";
		$ar_swtch	= $_POST["ar_swtch"];
		$ca_swtch	= $_POST["ca_swtch"];
		$ns_button 	= str_replace(",", "&#44;", trim(htmlspecialchars($_POST["ns_button"])));
		if (!$ns_button) $ns_button = "選択";

		$fp = fopen($inifile, "w");
		fwrite($fp, "$ar_swtch,$ca_swtch,$ar_count,$ar_title,$ca_title,$mb_count,$ns_button,\r\n",200);
		fclose($fp);

		$message = "設定を変更しました";
		$loadtabs = "1";
		break;
	
	default:
		$message = "";
		break;
}

include BLOGN_MODDIR.$module_name.'/menu.php';

echo $js.'
<div class="blogn_main">

<div'.formatStyle($style["wrapper"]).'>
<h1'.formatStyle($style["mod_title"]).'>プルダウンメニュー化モジュール (ver'.$module_version.')</h1>

<!-- LEFT -->
<div'.formatStyle($style["coll"]).'>
<h2'.formatStyle($style["coll_h2"]).'>メニュー</h2>
<ul'.formatStyle($style["coll_ul"]).'>';

module_control_list($menu);

echo '
</ul>
<noscript><p'.formatStyle($style["nojs"]).'>※ Javascript 無効<br />メニュー内のテキストリンクは機能しないので、● をクリックしてナビゲートしてください。</p></noscript>
<p'.formatStyle($style["credit"]).'>Powered by<br /><a href="http://i-njoy.net/blog/" target="_blank"'.formatStyle($style["credit_a"]).'>nJOY BLOG</a></p>
</div>
 
<!-- RIGHT -->
<div'.formatStyle($style["colr"]).'>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("設定", $menu).'">

<form method="post" action="./admin.php?mode=module&amp;action=edit">
<input type="hidden" name="blogn_module_name" value="'.$module_name.'">

<div class="blogn_bar">現在の設定</div>
<table border="1" cellspacing="0" cellpadding="3" width="400">
<tr bgcolor="#dcdcdc"><th colspan="2">月別</th></tr>
<tr>
<td bgcolor="#e9e9e9"><strong>スイッチ</strong></td>
<td>';
if ($ar_swtch) {
	echo '
<input type="radio" name="ar_swtch" value="1" checked="checked" /> ON
<input type="radio" name="ar_swtch" value="0" /> OFF';
} else {
	echo '
<input type="radio" name="ar_swtch" value="1" /> ON
<input type="radio" name="ar_swtch" value="0" checked="checked" /> OFF';
}
echo '</td></tr>

<tr><td bgcolor="#e9e9e9"><strong>表示文字列</strong></td>
<td><input type="text" name="ar_title" value="'.$ar_title.'" size="30" /></td>
</tr>

<tr>
<td bgcolor="#e9e9e9"><strong>表示件数（PC）</strong></td>
<td><select name="ar_count"'.formatStyle($style["sel_count"]).'">';

for ($i = 0; $i < 61; $i++) {
	if ($i == $ar_count) {
		$select = ' selected="selected"';
	} else {
		$select = "";
	}
	if ($i == 0) {
		$j = "無制限";
	} else {
		$j = $i.'件';
	}
	echo '<option value="'.$i.'"'.$select.'>'.$j.'</option>';
}
echo '
</select>
</td>
</tr>

<tr>
<td bgcolor="#e9e9e9"><strong>表示件数（携帯）</strong></td>
<td><select name="mb_count"'.formatStyle($style["sel_count"]).'">';

for ($i = 0; $i < 61; $i++) {
	if ($i == $mb_count) {
		$select = ' selected="selected"';
	} else {
		$select = "";
	}
	if ($i == 0) {
		$j = "無制限";
	} else {
		$j = $i.'件';
	}
	echo '<option value="'.$i.'"'.$select.'>'.$j.'</option>';
}
echo '
</select>
</td>
</tr>

<tr bgcolor="#dcdcdc"><th colspan="2">カテゴリー別</th></tr>
<tr>
<td bgcolor="#e9e9e9"><strong>スイッチ</strong></td>
<td>';
if ($ca_swtch) {
	echo '
<input type="radio" name="ca_swtch" value="1" checked="checked" /> ON
<input type="radio" name="ca_swtch" value="0" /> OFF';
} else {
	echo '
<input type="radio" name="ca_swtch" value="1" /> ON
<input type="radio" name="ca_swtch" value="0" checked="checked" /> OFF';
}
echo '</td></tr>

<tr><td bgcolor="#e9e9e9"><strong>表示文字列</strong></td>
<td><input type="text" name="ca_title" value="'.$ca_title.'" size="30" /></td>
</tr>

<tr bgcolor="#dcdcdc"><th colspan="2">共通（Javascript 未使用版）</th></tr>

<tr><td bgcolor="#e9e9e9"><strong>ボタン名</strong></td>
<td><input type="text" name="ns_button" value="'.$ns_button.'" size="30" /></td>
</tr>

</table>

<input type="hidden" name="method" value="edit">
<input type="submit" value="変更"'.formatStyle($style["button"]).'> <span'.formatStyle($style["message"]).'>'.$message.'</span>
</form>

<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("独自タグ", $menu).'">
<div class="blogn_bar">独自タグ</div>
<div'.formatStyle($style["mod"]).'>

<h2'.formatStyle($style["mod_h2"]).'>このモジュールで使える独自タグ</h2>

<h3'.formatStyle($style["mod_h3"]).'>■ 月別メニュー</h3>
<table border="1" cellspacing="0" cellpadding="3" width="500"'.formatStyle($style["mod_table"]).'>
<tr bgcolor="#dcdcdc"><th width="200">独自タグ</th><th width="250">説明</th><th width="50">補足</th></tr>
<tr><td>{PDM_AR}</td><td>開始タグ（Javascript 使用）</td><td>必須</td></tr>
<tr><td>{PDM_ARNS}</td><td>開始タグ（Javascript 未使用）</td><td>必須</td></tr>
<tr><td>{PDM_ARLOOP}</td><td>ループ処理開始タグ</td><td>必須</td></tr>
<tr><td>{PDM_ARLINK}</td><td>選択肢開始</td><td>必須</td></tr>
<tr><td>{PDM_ARYM} ～ {/PDM_ARYM}</td><td>年月出力</td><td>必須</td></tr>
<tr><td>{PDM_ARCOUNT}</td><td>記事件数</td><td>-</td></tr>
<tr><td>{/PDM_ARLINK}</td><td>選択肢終了</td><td>必須</td></tr>
<tr><td>{/PDM_ARLOOP}</td><td>ループ処理終了タグ</td><td>必須</td></tr>
<tr><td>{/PDM_AR}</td><td>終了タグ</td><td>必須</td></tr>
</table>

<h3'.formatStyle($style["mod_h3"]).'>■ カテゴリー別メニュー</h3>
<table border="1" cellspacing="0" cellpadding="3" width="500"'.formatStyle($style["mod_table"]).'>
<tr bgcolor="#dcdcdc"><th width="200">独自タグ</th><th width="250">説明</th><th width="50">補足</th></tr>
<tr><td>{PDM_CA}</td><td>開始タグ（Javascript 使用）</td><td>必須</td></tr>
<tr><td>{PDM_CANS}</td><td>開始タグ（Javascript 未使用）</td><td>必須</td></tr>
<tr><td>{PDM_CAH}</td><td>開始タグ（Javascript 使用）</td><td>必須</td></tr>
<tr><td>{PDM_CAHNS}</td><td>開始タグ（Javascript 未使用）</td><td>必須</td></tr>
<tr><td>{PDM_CALOOP1}</td><td>ループ処理開始タグ（メイン）</td><td>必須</td></tr>
<tr><td>{PDM_CALINK1}</td><td>選択肢開始（メイン）</td><td>必須</td></tr>
<tr><td>{PDM_CATITLE1}</td><td>メインカテゴリー名</td><td>必須</td></tr>
<tr><td>{PDM_CACOUNT1}</td><td>記事件数（メイン）</td><td>-</td></tr>
<tr><td>{/PDM_CALINK1}</td><td>選択肢終了（メイン）</td><td>必須</td></tr>
<tr><td>{PDM_CALOOP2}</td><td>ループ処理開始（サブ）</td><td>-</td></tr>
<tr><td>{PDM_CALINK2}</td><td>選択肢開始（サブ）</td><td>-</td></tr>
<tr><td>{PDM_CATITLE2}</td><td>サブカテゴリー名</td><td>-</td></tr>
<tr><td>{PDM_CACOUNT2}</td><td>記事件数（サブ）</td><td>-</td></tr>
<tr><td>{/PDM_CALINK2}</td><td>選択肢終了（サブ）</td><td>-</td></tr>
<tr><td>{/PDM_CALOOP2}</td><td>ループ処理終了タグ（サブ）</td><td>-</td></tr>
<tr><td>{/PDM_CALOOP1}</td><td>ループ処理終了タグ（メイン）</td><td>必須</td></tr>
<tr><td>{/PDM_CA}</td><td>終了タグ</td><td>必須</td></tr>
</table>

<h2'.formatStyle($style["mod_h2"]).'>このモジュールで出力するスタイルシート用 id 属性</h2>

<table border="1" cellspacing="0" cellpadding="3" width="500"'.formatStyle($style["mod_table"]).'>
<tr bgcolor="#dcdcdc"><th width="100">id 属性</th><th>説明</th><th width="50">HTML</th><th width="50">補足</th></tr>
<tr><td>pdm_arform</td><td>月別フォーム</td><td>form</td><td>-</td></tr>
<tr><td>pdm_arslct</td><td>月別セレクトボックス</td><td>select</td><td>-</td></tr>
<tr><td>pdm_arbutton</td><td>月別ボタン（Javascript 未使用時）</td><td>input</td><td>-</td></tr>
<tr><td>pdm_caform</td><td>カテゴリー別フォーム</td><td>form</td><td>-</td></tr>
<tr><td>pdm_caslct</td><td>カテゴリー別セレクトボックス</td><td>select</td><td>-</td></tr>
<tr><td>pdm_cabutton</td><td>カテゴリー別ボタン（Javascript 未使用時）</td><td>input</td><td>-</td></tr>

</table>

</div>
<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("インストール", $menu).'">
<div class="blogn_bar">インストール</div>
<div'.formatStyle($style["mod"]).'>

<h2'.formatStyle($style["mod_h2"]).'>インストール方法</h2>
<ol'.formatStyle($style["mod_list"]).'>
<li>「config.cgi」のパーミッションを「666」等に変更する。</li>
<li>設定を変更する。</li>
<li>スキンの HTML ファイルに独自タグを追加する。</li>
'.$mod_control["co_start"].'<li>必要に応じてモジュール管理画面から動作スイッチを ON にする必要があります。</li>'.$mod_control["co_end"].'
</ol>

<h3'.formatStyle($style["mod_h3"]).'>■ スキンの HTML ファイルへの記述例（月別用）</h3>
<p'.formatStyle($style["mod_p"]).'>Javascript 使用版</p>
<pre'.formatStyle($style["pre"]).'>
{PDM_AR} 
{PDM_ARLOOP} 
{PDM_ARLINK}{PDM_ARYM}Y年m月{/PDM_ARYM}({PDM_ARCOUNT}件){/PDM_ARLINK} 
{/PDM_ARLOOP} 
{/PDM_AR}
</pre>
<p'.formatStyle($style["mod_p"]).'>Javascript 未使用版</p>
<pre'.formatStyle($style["pre"]).'>
{PDM_ARNS} 
{PDM_ARLOOP} 
{PDM_ARLINK}{PDM_ARYM}Y年m月{/PDM_ARYM}({PDM_ARCOUNT}件){/PDM_ARLINK} 
{/PDM_ARLOOP} 
{/PDM_AR}
</pre>

<h3'.formatStyle($style["mod_h3"]).'>■ スキンの HTML ファイルへの記述例（カテゴリー別用 その1）</h3>
<p'.formatStyle($style["mod_p"]).'>Javascript 使用版</p>
<pre'.formatStyle($style["pre"]).'>
{PDM_CA} 
{PDM_CALOOP1} 
{PDM_CALINK1}{PDM_CATITLE1} ({PDM_CACOUNT1}件){/PDM_CALINK1} 
{PDM_CALOOP2} 
{PDM_CALINK2}└ {PDM_CATITLE2} ({PDM_CACOUNT2}件){/PDM_CALINK2} 
{/PDM_CALOOP2} 
{/PDM_CALOOP1} 
{/PDM_CA}
</pre>
<p'.formatStyle($style["mod_p"]).'>Javascript 未使用版</p>
<pre'.formatStyle($style["pre"]).'>
{PDM_CANS} 
{PDM_CALOOP1} 
{PDM_CALINK1}{PDM_CATITLE1} ({PDM_CACOUNT1}件){/PDM_CALINK1} 
{PDM_CALOOP2} 
{PDM_CALINK2}└ {PDM_CATITLE2} ({PDM_CACOUNT2}件){/PDM_CALINK2} 
{/PDM_CALOOP2} 
{/PDM_CALOOP1} 
{/PDM_CA}
</pre>

<h3'.formatStyle($style["mod_h3"]).'>■ スキンの HTML ファイルへの記述例（カテゴリー別用 その2）</h3>
<p'.formatStyle($style["mod_p"]).'>サブカテゴリーのみプルダウンメニュー化する形式も用意しています。<br />詳しくはモジュールの解説ページを参照してください。</p>


</div>

<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("モジュール情報", $menu).'">
<div class="blogn_bar">モジュール情報</div>
<div'.formatStyle($style["mod"]).'>

<h2'.formatStyle($style["mod_h2"]).'>公式サイト</h2>
<p'.formatStyle($style["mod_p"]).'>もっと詳しい情報や最新版モジュールのダウンロードは「<a href="http://i-njoy.net/tips/plus_pdm.shtml" target="_blank">プルダウンメニュー化モジュール</a>」の解説ページからどうぞ。</p>
<p'.formatStyle($style["mod_p"]).'>最新情報は「<a href="http://i-njoy.net/blog/" target="_blank">nJOY BLOG</a>」から入手できます。</p>

<h2'.formatStyle($style["mod_h2"]).'>モジュール構成ファイル</h2>
<ul'.formatStyle($style["package"]).'>
<li'.formatStyle($style["pack_0"]).'>+ blognplus /</li>
<li'.formatStyle($style["pack_1"]).'>+ module /</li>
<li'.formatStyle($style["pack_2"]).'>+ pulldown /</li>
<li'.formatStyle($style["pack_3"]).'>- blank.php</li>
<li'.formatStyle($style["pack_3"]).'>- <span'.formatStyle($style["red"]).'>config.cgi</span></li>
<li'.formatStyle($style["pack_3"]).'>- control.php</li>
<li'.formatStyle($style["pack_3"]).'>- index.html</li>
<li'.formatStyle($style["pack_3"]).'>- info.php</li>
<li'.formatStyle($style["pack_3"]).'>- install.php</li>
<li'.formatStyle($style["pack_3"]).'>- menu.php</li>
<li'.formatStyle($style["pack_3"]).'>- style.php</li>
<li'.formatStyle($style["pack_3"]).'>- uninstall.php</li>
<li'.formatStyle($style["pack_3"]).'>- update.php</li>
<li'.formatStyle($style["pack_3"]).'>- viewer.php</li>
</ul>

<p'.formatStyle($style["mod_p"]).'><span'.formatStyle($style["red"]).'>赤文字のファイル</span>のパーミッションは「666」や「606」に変更してください。</p>

'.$mod_control["co_start"].'
<h2'.formatStyle($style["mod_h2"]).'>動作 ON/OFF</h2>
<p'.formatStyle($style["mod_p"]).'>モジュールをインストール後に、動作のオン・オフを切り替える必要があります。</p>
<dl'.formatStyle($style["mod_dl"]).'>
<dt>PC</dt><dd>PC 用スキンに独自タグを記述した場合、「PC」欄を <img src="images/on.gif" width="20" height="20" alt="ON" /> にしてください。</dd>
<dt>携帯</dt><dd>携帯用スキンに独自タグ（Javascript 未使用版）を記述した場合、「携帯」欄を <img src="images/on.gif" width="20" height="20" alt="ON" /> にしてください。</dd>
</dl>

<h2'.formatStyle($style["mod_h2"]).'>優先順位</h2>
<p'.formatStyle($style["mod_p"]).'>特に制限はありません。</p>
'.$mod_control["co_end"].'

</div>
<hr'.formatStyle($style["hr"]).' />
</div>

</div>
</div>
</div>';

?>
